#!/bin/sh -e

rm -Rf work/*

cd config

cd types
echo "Generating: types.h" 1>&2
./gentypes.sh ../../work > ../../work/types.h
echo "Verifying: types.h" 1>&2
./chktypes.sh ../../work ../../work
cd ..
CCI opts-config.c -o ../work/opts-config.o
LDI ../work/opts-config ../work/opts-config.o
./../work/opts-config "$@" > ../work/config.h
./syslib/config.sh ../work syslib >> ../work/config.h
# not all systems supports "grep -F", some of them have fgrep instead
# use plain grep as we don't use regexp special symbols
grep -v remove-this-line-by-config ../string.tpl.h > ../work/string.h
if grep HAVE_EXPLICIT_BZERO ../work/config.h >> /dev/null; then
  grep -v "define FCL_EXPLICIT_BZERO" ../work/string.h > ../work/string.hh
  mv ../work/string.hh ../work/string.h
fi
if grep HAVE_STRLCPY ../work/config.h >> /dev/null; then
  grep -v "define FCL_STRLCPY" ../work/string.h > ../work/string.hh
  mv ../work/string.hh ../work/string.h
fi
if grep HAVE_STRCHRNUL ../work/config.h >> /dev/null; then
  # we have strchrnul() by default from string(s).h
  grep -v "define FCL_STRCHRNUL" ../work/string.h > ../work/string.hh
  mv ../work/string.hh ../work/string.h
elif ! grep HAVE_GNU_STRCHRNUL ../work/config.h >> /dev/null; then
  # we have NOT strchrnul() even with _GNU_SOURCE from string(s).h
  grep -v "define FCL_STRCHRNUL_GNU" ../work/string.h > ../work/string.hh
  mv ../work/string.hh ../work/string.h
fi
if grep FCL_NO_STRERROR ../work/config.h >> /dev/null; then
  echo "strerror() caching disabled"
else
  CCI errno-gen.c -o ../work/errno-gen.o
  LDI ../work/errno-gen ../work/errno-gen.o
  ./../work/errno-gen > ../work/strerror.inc
fi
